<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		    */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                        */
/*		email : thelia@octolys.fr		        	                             	          */
/*      web : http://www.octolys.fr						   							          */
/*																												 */
/*		  Modifié par brunoa <kermorweb@free.fr> (c)2009										 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");

	class Tarif {
		var $mini;
		var $maxi;
		var $valeur;

		function Tarif($mini,$maxi,$valeur){
			$this->mini=$mini;
			$this->maxi=$maxi;
			$this->valeur=$valeur;
		}
	}

	class Tarifs {
		var $tabtarifs=array();
		var $fichier;
		
		function Tarifs($chargeXML=true){
			$this->fichier=realpath(dirname(__FILE__)) . '/tarif.xml';
			if($chargeXML)
				$this->chargeTarifsXML();
		}

		function ajouteTarif($min,$max,$valeur){
			if($min==-1){
				if(count($this->tabtarifs)>0)
					$min=$this->tabtarifs[count($this->tabtarifs)-1]->maxi;
				else
					$min=0;
			}
			$tarif=new Tarif($min,$max,$valeur);
			array_push($this->tabtarifs,$tarif);
		}		

		function chargeTarifsXML(){
			$sxml=simplexml_load_file($this->fichier);
			foreach($sxml->tarif as $tarif){
				if(isset($tarif['pmin'])){
					$mini=$tarif['pmin'];
				}else{
					$mini=-1;
				}
				$this->ajouteTarif($mini,$tarif['pmax'],$tarif['value']);
			}
		}

		function obtientPrix($poids){
			foreach($this->tabtarifs as $tarif)
				if($poids>$tarif->mini && $poids<=$tarif->maxi)
					return $tarif->valeur;
			return 0;
		}	

		function ecritTarifsXML(){
			if(!($fic=fopen($this->fichier,"w")))
				die("Impossible d'ouvrir $this->fichier");
			$string="<colissimo>\n";
			foreach($this->tabtarifs as $tarif){
				$string.="\t<tarif pmin=\"".$tarif->mini."\" pmax=\"".$tarif->maxi."\" value=\"".$tarif->valeur."\"/>\n";
			}
			$string.="</colissimo>\n";	
			fwrite($fic,$string);
			fclose($fic);		
		}	
	}

	class Colissimo extends PluginsTransports{


		function Colissimo(){
			$this->PluginsTransports("colissimo");
		}

		function ajout_desc($titre, $chapo, $description, $lang=1, $devise=""){
					
			$modulesdesc = new Modulesdesc();
			$res = $modulesdesc->verif($this->nom_plugin, $lang);
			
			$modulesdesc->plugin = $this->nom_plugin;
			$modulesdesc->titre = $titre;
			$modulesdesc->chapo = $chapo;
			$modulesdesc->description = $description;
			$modulesdesc->lang = $lang;
			$modulesdesc->devise = $devise;
			
			if($res)
				$modulesdesc->maj();
			else $modulesdesc->add();
			
			
		}

		
		function init(){
			$this->ajout_desc("Colissimo", "Gestion des Colissimo", "", 1);
			$test = new Message();
			if(! $test->charger("colissimo")){
				$message = new Message();
				$message->nom = "colissimo";
				$lastid = $message->add();

				$messagedesc = new Messagedesc();
				$messagedesc->message = $lastid;
				$messagedesc->lang = 1;
				$messagedesc->titre = "Colissimo";
				$messagedesc->description = "__RAISON__ __NOM__ __PRENOM__,\n\nNous vous remercions de votre commande sur notre site __URLSITE__\n\nUn colis concernant votre commande __COMMANDE__ du __DATE__ __HEURE__ a quitt� nos entrep�ts pour �tre pris en charge par La Poste le __DATEDJ__.\n\nSon num�ro de suivi est le suivant : __COLIS__\nIl vous permet de suivre votre colis en ligne sur le site de La Poste : www.coliposte.net\nIl vous sera, par ailleurs, tr�s utile si vous �tiez absent au moment de la livraison de votre colis : en fournissant ce num�ro de Colissimo Suivi, vous pourrez retirer votre colis dans le bureau de Poste le plus proche.\n\nATTENTION ! Si vous ne trouvez pas l'avis de passage normalement d�pos� dans votre bo�te aux lettres au bout de 48 Heures jours ouvrables, n'h�sitez pas � aller le r�clamer � votre bureau de Poste, muni de votre num�ro de Colissimo Suivi.\n\nNous restons � votre disposition pour toute information compl�mentaire.\nCordialement";
				$messagedesc->add();

			}
		}
		
		function calcule(){
			$tarifs=new Tarifs();
			return $tarifs->obtientPrix($this->poids);
		}
			
		function statut($commande){

			if($commande->statut == "4"){

				if(! $commande->colis)
					return;

				$message = new Message();
				$message->charger("colissimo");

				$messagedesc = new Messagedesc();
				$messagedesc->charger($message->id);

				$client = new Client();
				$client->charger_id($commande->client);

				if($client->raison == "1")
					$raison = "Madame";
				else
					if($client->raison == "2")
						$raison = "Mademoiselle";
				else
					if($client->raison == "3")
						$raison = "Monsieur";

				$urlsite = new Variable();
				$urlsite->charger("urlsite");

				$emailcontact = new Variable();
				$emailcontact->charger("emailcontact");

          			$jour = substr($commande->date, 8, 2);
		        	$mois = substr($commande->date, 5, 2);
		        	$annee = substr($commande->date, 0, 4);
                		$heure = substr($commande->date, 11, 2);
		                $minute = substr($commande->date, 14, 2);
                		$seconde = substr($commande->date, 17, 2);

				$messagedesc->description = str_replace("__RAISON__", "$raison", $messagedesc->description);
				$messagedesc->description = str_replace("__NOM__", $client->nom, $messagedesc->description);
				$messagedesc->description = str_replace("__PRENOM__", $client->prenom, $messagedesc->description);
				$messagedesc->description = str_replace("__URLSITE__", $urlsite->valeur, $messagedesc->description);
				$messagedesc->description = str_replace("__COMMANDE__", $commande->ref, $messagedesc->description);
				$messagedesc->description = str_replace("__DATE__", $jour . "/" . $mois . "/" . $annee, $messagedesc->description);
				$messagedesc->description = str_replace("__HEURE__", $heure . ":" . $minute . ":" . $seconde, $messagedesc->description);
				$messagedesc->description = str_replace("__DATEDJ__", date("d") . "/" . date("m") . "/" . date("Y"), $messagedesc->description);
				$messagedesc->description = str_replace("__COLIS__", $commande->colis, $messagedesc->description);
				mail($client->email, $messagedesc->titre, $messagedesc->description, "From: " . $emailcontact->valeur);

			}

		}

	}

?>
